/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gpl.fredy.sqltools;


/**
 * This is a class used to store the values used for the XMLimport
 * to create the insert-Prepared-Statement it contains:
 *
 * int sequence             this indicates the sequence this object must be inserted to
 *                          be in sync with the prepared statement
 *
 * String attributeName     this is the name of the tableattribute
 * String attributeValue    this is the string representation of the fieldvalue
 * String attributeType     this is the type of the attribute
 *
 *
 * Admin is a Tool around JDBC-enabled SQL-Databases to do basic jobs
 * for DB-Administrations, as create / delete / alter and query tables
 * it also creates indices and generates simple Java-Code to access DBMS-tables
 * and exports data into various formats
 *
 *
 *   Copyright (C)     2010, Fredy Fischer
 *                           sql@hulmen.ch
 *   Postal: Fredy Fischer
 *           Hulmenweg 36
 *           8405 Winterthur
 *           Switzerland
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

/**
 *
 * @author afs
 */
public class XMLinputField {
    private int sequence = 0;
    private String attributeName = null;
    private String attributeValue = null;
    private String attributeType = null;


    public XMLinputField(int s, String n,String v,String t) {

        this.setSequence(s);
        this.setAttributeName(n);
        this.setAttributeValue(v);
        this.setAttributeType(t);
    }

   public XMLinputField() {
       // just nothing
   }

    /**
     * @return the sequence
     */
    public int getSequence() {
        return sequence;
    }

    /**
     * @param sequence the sequence to set
     */
    public void setSequence(int sequence) {
        this.sequence = sequence;
    }

    /**
     * @return the attributeName
     */
    public String getAttributeName() {
        return attributeName;
    }

    /**
     * @param attributeName the attributeName to set
     */
    public void setAttributeName(String atributeName) {
        this.attributeName = atributeName;
    }

    /**
     * @return the attributeValue
     */
    public String getAttributeValue() {
        return attributeValue;
    }

    /**
     * @param attributeValue the attributeValue to set
     */
    public void setAttributeValue(String attributeValue) {
        this.attributeValue = attributeValue;
    }

    /**
     * @return the attributeType
     */
    public String getAttributeType() {
        return attributeType;
    }

    /**
     * @param attributeType the attributeType to set
     */
    public void setAttributeType(String attributeType) {
        this.attributeType = attributeType;
    }

}
