package gpl.fredy.webmail;

import gpl.fredy.io.ReadFile;
//import gpl.fredy.share.*;
import gpl.fredy.ui.CloseableFrame;

import java.awt.*;
import java.awt.Font.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.BorderFactory; 
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.text.*;


import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.mail.*;
import javax.mail.internet.*;
import java.io.*;

public class MassSender extends CloseableFrame {

    private JTextField smtpHost, smtpUser;
    private JTextField subject, from;
    private JTextArea  text;
    private JList      receiver;
    private JCheckBox  single, sendEach;
    private Vector     rcv;
    public JButton exit;
    private Session session;
    private Message message;

    public MassSender() {
	super("Mass Sender");

	this.getContentPane().setLayout(new GridBagLayout());

	GridBagConstraints gbc;
	Insets insets = new Insets(1,1,1,1);
	gbc = new GridBagConstraints();
	gbc.weightx = 1.0;     
	gbc.anchor= GridBagConstraints.WEST;
	gbc.fill  = GridBagConstraints.HORIZONTAL;
	gbc.insets = insets;
        
	gbc.gridx = 0;
	gbc.gridy = 0;
	gbc.gridheight = 4;

        this.getContentPane().add(paramPanel(),gbc);

	gbc.gridx = 1;
	gbc.gridy = 0;
	gbc.gridheight = 5;
        this.getContentPane().add(receiverPanel(),gbc);

 	gbc.gridx = 0;
	gbc.gridy = 6;
        gbc.gridwidth=2;
	gbc.gridheight = 5;
	gbc.fill  = GridBagConstraints.HORIZONTAL;
        this.getContentPane().add(messagePanel(),gbc);  

 	gbc.gridx = 0;
	gbc.gridy = 11;
        gbc.gridwidth=2;
	gbc.gridheight = 1;

        this.getContentPane().add(buttonPanel(),gbc);  

	this.pack();
	this.setVisible(true);
    }

    private JPanel paramPanel() {

	JPanel panel = new JPanel();
	panel.setLayout(new GridBagLayout());
	GridBagConstraints gbc;
	Insets insets = new Insets(1,1,1,1);
	gbc = new GridBagConstraints();
	gbc.weightx = 1.0;     
	gbc.anchor= GridBagConstraints.WEST;
	gbc.fill  = GridBagConstraints.NONE;
	gbc.insets = insets;
        
	smtpHost = new JTextField(15);
        smtpUser = new JTextField(15);
        subject  = new JTextField(15);
        from     = new JTextField(15);
	
	gbc.gridx = 0;
	gbc.gridy = 0;
        panel.add(new JLabel("SMTP-Host"),gbc);
	gbc.gridx = 1;
        panel.add(smtpHost,gbc);

	gbc.gridx = 0;
	gbc.gridy = 1;
        panel.add(new JLabel("SMTP-User"),gbc);
	gbc.gridx = 1;
        //panel.add(smtpUser,gbc);

 
	gbc.gridx = 0;
	gbc.gridy = 2;
        panel.add(new JLabel("From"),gbc);
	gbc.gridx = 1;
        panel.add(from,gbc);
 
	gbc.gridx = 0;
	gbc.gridy = 3;
        panel.add(new JLabel("Subject"),gbc);
	gbc.gridx = 1;
        panel.add(subject,gbc);

	gbc.gridx = 0;
	gbc.gridy = 4;
        panel.add(new JLabel("Single Mail"),gbc);
	gbc.gridx = 1;

	single = new JCheckBox();
	single.setToolTipText("Send each mail for its own");
        panel.add(single,gbc);


	gbc.gridx = 0;
	gbc.gridy = 5;
        panel.add(new JLabel("send mail by mail"),gbc);
	gbc.gridx = 1;

	sendEach = new JCheckBox();
	sendEach.setToolTipText("every click on send, sends next Mail");
        panel.add(sendEach,gbc);



	panel.setBorder(BorderFactory.createEtchedBorder());

	return panel;
    }

 
    private JPanel receiverPanel() {

	JPanel panel = new JPanel();
	panel.setLayout(new GridBagLayout());
	GridBagConstraints gbc;
	Insets insets = new Insets(1,1,1,1);
	gbc = new GridBagConstraints();
	gbc.weightx = 1.0;     
	gbc.anchor= GridBagConstraints.WEST;
	gbc.fill  = GridBagConstraints.NONE;
	gbc.insets = insets;

        rcv     = new Vector();
	receiver = new JList(rcv);
	receiver.setVisibleRowCount(5);
	
	gbc.gridx = 0;
	gbc.gridy = 0;
	JScrollPane s = new JScrollPane(receiver);
        panel.add(s,gbc);

	panel.setBorder(new TitledBorder("Receiver"));

	JPanel bPanel = new JPanel();
        bPanel.setLayout(new FlowLayout());

        JButton loadList = new JButton("load");
        loadList.setToolTipText("loads receivers from file");
	loadList.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    ReadFile rf = new ReadFile();
		    rf.setFilter(new String[] {"lst","txt","TXT"});
		    rf.setFileName("?");
		    Vector v = rf.getLines();
		    for (int i=0;i< v.size();i++) {
			rcv.addElement(v.elementAt(i));
		    }
		    receiver.updateUI();
		}
	    });
	


	JButton addReceiver = new JButton("add");
	addReceiver.setToolTipText("add single receiver manually");
	addReceiver.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    String a="";
		    if (( a = JOptionPane.showInputDialog(null,"E-Mail")) != null ) {
			rcv.addElement(a);
			receiver.updateUI();
		    }

		}
	    });
	

	JButton clear = new JButton("Clear");
	clear.setToolTipText("clear list");
	clear.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    rcv = new Vector();
		    receiver.setListData(rcv);
		    receiver.updateUI();
		}
	    });
	

	JButton delete = new JButton("Delete");
	delete.setToolTipText("remove selected Mail from List");
	delete.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    int i = receiver.getSelectedIndex();
		    if ( i > -1 ) {
			rcv.remove(i);
			receiver.updateUI();
		    }
		}
	    });
	


        bPanel.add(loadList);
	bPanel.add(addReceiver);
        bPanel.add(clear);
	bPanel.add(delete);
        bPanel.setBorder(new EtchedBorder());

	gbc.gridx = 0;
	gbc.gridy = 1;
        panel.add(bPanel,gbc);

	return panel;
    }


	
    private JPanel messagePanel() {
	JPanel panel = new JPanel();
	panel.setLayout(new BorderLayout());
	
	text = new JTextArea(15,30);
	JScrollPane scp = new JScrollPane(text);
        panel.add(scp,BorderLayout.CENTER);
	panel.setBorder(new TitledBorder("Message"));
        
	return panel;
    }

    private JPanel buttonPanel() {
	JPanel panel = new JPanel();
	panel.setLayout(new FlowLayout());
	JButton send = new JButton("Send");
	exit = new JButton("exit");

	send.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    if ( ! sendEach.isSelected() ) {
			sendMail();
		    } else {
			sendSingleMail(receiver.getSelectedIndex());
			receiver.setSelectedIndex(receiver.getSelectedIndex() + 1);
		    }
		}
	    });
	

	panel.add(send);
	panel.add(exit);
	panel.setBorder(new EtchedBorder());
	return panel;
    }



    private void sendMail() {
	Properties props = System.getProperties();
	props.put("mail.smtp.host", smtpHost.getText());
	session = Session.getDefaultInstance(props, null);

	SendMessage     send;
 
	if (  single.isSelected() ) {
	  for (int j = 0; j < rcv.size();j++) {
	    send = new SendMessage(session);
	    send.setFrom(from.getText());
	    send.setSubject(subject.getText());
	    send.setText(text.getText());	    
            send.addTO( (String)rcv.elementAt(j) );
	    if ( ! send.send() ) {
	      text.setText(send.getErr());
	      text.updateUI();            
	    }
	  }
	} else {
	  send = new SendMessage(session);
	  send.setFrom(from.getText());
 	  send.setSubject(subject.getText());
          send.setText(text.getText());

	  String r ="";
	  for (int i = 0;i< rcv.size();i++) {
	    if ( i > 0) r = r + ",";
            r = r + rcv.elementAt(i);
	  }
	  send.addLot(Message.RecipientType.TO,r);
	  if ( ! send.send() ) {
	    text.setText(send.getErr());
	    text.updateUI();
	  }
	}
	
  
    }

     private void sendSingleMail(int j) {
	Properties props = System.getProperties();
	props.put("mail.smtp.host", smtpHost.getText());
	session = Session.getDefaultInstance(props, null);

	if ( j < 0 ) {
	    j = 0;
	    receiver.setSelectedIndex(j);
	}

	SendMessage     send;

	send = new SendMessage(session);
	send.setFrom(from.getText());
	send.setSubject(subject.getText());
	send.setText(text.getText());	    
	send.addTO( (String)rcv.elementAt(j) );
	if ( ! send.send() ) {
	    System.out.println(send.getErr());
	}         
    }

    public static void main(String a[]) {
	MassSender m = new MassSender();
	m.exit.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    System.exit(0);
		}
	    });
	
    }
}
